"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStrapiMiddleware = void 0;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var http_request_1 = __importDefault(require("../../http/http.request"));
var jsonwebtoken = __importStar(require("jsonwebtoken"));
var redis_operators_1 = require("../../redis/redis.operators");
var verifyJWT$ = rxjs_1.bindNodeCallback(jsonwebtoken.verify);
function createStrapiMiddleware(_a) {
    var REDIS_JWT_KEY = _a.REDIS_JWT_KEY, STRAPI_IDENTIFIER = _a.STRAPI_IDENTIFIER, STRAPI_PASSWORD = _a.STRAPI_PASSWORD, STRAPI_URL = _a.STRAPI_URL, REDIS_JWT_TTL_SECONDS = _a.REDIS_JWT_TTL_SECONDS, STRAPI_JWT_SEED = _a.STRAPI_JWT_SEED, redisClient = _a.redisClient;
    function fetchToken$() {
        var OPTIONS = {
            method: 'POST',
            headers: {
                'content-type': 'application/json',
            },
            body: JSON.stringify({
                identifier: STRAPI_IDENTIFIER,
                password: STRAPI_PASSWORD,
            }),
        };
        return rxjs_1.from(http_request_1.default(STRAPI_URL + "/auth/local", OPTIONS)).pipe(operators_1.switchMap(function (_a) {
            var jwt = _a.jwt;
            return rxjs_1.forkJoin({
                savedToken: redis_operators_1.redisSetX$({
                    redisClient: redisClient,
                    key: REDIS_JWT_KEY,
                    seconds: REDIS_JWT_TTL_SECONDS,
                    data: jwt,
                }),
                tokenResponse: rxjs_1.of({ token: jwt, source: 'STRAPI' }),
            });
        }), operators_1.map(function (_a) {
            var tokenResponse = _a.tokenResponse;
            return tokenResponse;
        }));
    }
    function verifyToken$(cachedToken) {
        var instanceOfError = function (err) { return err instanceof Error || (err && err.name); };
        var isError = function (err) {
            if (instanceOfError(err))
                return true;
            if (Array.isArray(err) && err && instanceOfError(err[0])) {
                return true;
            }
            return false;
        };
        var root$ = verifyJWT$(cachedToken, STRAPI_JWT_SEED).pipe(operators_1.shareReplay());
        var verified$ = root$.pipe(operators_1.filter(function (verified) { return isError(verified); }), operators_1.switchMap(function () { return fetchToken$(); }));
        var notVerified$ = root$.pipe(operators_1.filter(function (verified) { return !isError(verified); }), operators_1.switchMap(function () { return rxjs_1.of({ token: cachedToken, source: 'REDIS' }); }));
        return rxjs_1.merge(verified$, notVerified$);
    }
    return function strapiJWT(req, res, next) {
        return __awaiter(this, void 0, void 0, function () {
            var root$, withToken$, withNoToken$;
            return __generator(this, function (_a) {
                root$ = redis_operators_1.redisGet$({ redisClient: redisClient, key: REDIS_JWT_KEY }).pipe(operators_1.shareReplay());
                withToken$ = root$.pipe(operators_1.filter(function (cachedToken) { return cachedToken === null; }), operators_1.switchMap(function () { return fetchToken$(); }));
                withNoToken$ = root$.pipe(operators_1.filter(function (cachedToken) { return cachedToken !== null; }), operators_1.switchMap(function (cachedToken) { return verifyToken$(cachedToken); }));
                rxjs_1.merge(withToken$, withNoToken$).subscribe({
                    next: function (_a) {
                        var token = _a.token;
                        req.user = {
                            id: null,
                            isAuthenticated: false,
                            jwt: token,
                            username: STRAPI_IDENTIFIER,
                            email: null,
                        };
                        next();
                    },
                    error: function (err) { return next(err); },
                });
                return [2 /*return*/];
            });
        });
    };
}
exports.createStrapiMiddleware = createStrapiMiddleware;
