import _env from './env';
import { envN as _envN } from './env';
import { extractRelativeUrl } from './cloudinary/url.util';
import { logger, setLogger } from './logger';
import { displaySuccessMessage } from './express/server.messages';
import { createStrapiMiddleware } from './express/middleware/strapi.middleware';
import { createRequestDecorator } from './express/middleware/decorate.request';
import { createRedisSessionMiddlewares$ } from './express/redis.session';
import { createRedis } from './redis/redis.connect';
import { searchService, searchService$ } from './redis/search.service';
import { getIPAdress } from './net/net.util';
export declare const Greeter: (name: string) => string;
export declare const env: typeof _env;
export declare const envN: typeof _envN;
export declare const Cloudinary: {
    extractRelativeUrl: typeof extractRelativeUrl;
};
export declare const Logger: {
    logger: typeof logger;
    setLogger: typeof setLogger;
};
export declare const NET: {
    getIPAdress: typeof getIPAdress;
};
export declare const Express: {
    displaySuccessMessage: typeof displaySuccessMessage;
    createStrapiMiddleware: typeof createStrapiMiddleware;
    createRequestDecorator: typeof createRequestDecorator;
    createRedisSessionMiddlewares$: typeof createRedisSessionMiddlewares$;
};
export declare const RX: {
    debugKeyRx: (message: string, key: string) => (source: import("rxjs").Observable<any>) => import("rxjs").Observable<any>;
    debugMessageRx: (message: string) => (source: import("rxjs").Observable<any>) => import("rxjs").Observable<any>;
    debugrx: (message: string) => (source: import("rxjs").Observable<any>) => import("rxjs").Observable<any>;
};
export declare const Redis: {
    createRedis: typeof createRedis;
    redisClient: () => import("redis-modules-sdk").Redis;
    searchService: typeof searchService;
    searchService$: typeof searchService$;
    redisGet$({ redisClient, key }: import("./types/redis.types").RedisGetParms): import("rxjs").Observable<any>;
    redisMusGet$({ redisClient, key }: import("./types/redis.types").RedisGetParms): import("rxjs").Observable<any>;
    redisSet$({ redisClient, key, data }: import("./types/redis.types").RedisSetParms): import("rxjs").Observable<any>;
    redisSetX$({ redisClient, key, seconds, data }: import("./types/redis.types").RedisSetXParms): import("rxjs").Observable<any>;
    redisJSONGet$({ redisClient, key }: import("./types/redis.types").RedisGetParms): import("rxjs").Observable<any>;
    redisJSONMustGet$({ redisClient, key }: import("./types/redis.types").RedisGetParms): import("rxjs").Observable<any>;
    redisJSONSet({ redisClient, key, data }: import("./types/redis.types").RedisJsonSetParms): import("rxjs").Observable<any>;
    redisExpire({ redisClient, key, seconds }: import("./types/redis.types").RedisExpireParms): import("rxjs").Observable<any>;
    redisJSONSetX({ redisClient, key, data, seconds }: import("./types/redis.types").RedisJsonSetXParms): import("rxjs").Observable<any>;
    redisFTInfo$({ redisClient, key }: import("./types/redis.types").RedisGetParms): import("rxjs").Observable<import("redis-modules-sdk").FTInfo>;
    redisIndexNumDocs({ redisClient, key }: import("./types/redis.types").RedisGetParms): import("rxjs").Observable<any>;
};
