"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Redis = exports.RX = exports.Express = exports.NET = exports.Logger = exports.Cloudinary = exports.envN = exports.env = exports.Greeter = void 0;
var env_1 = __importDefault(require("./env"));
var env_2 = require("./env");
var url_util_1 = require("./cloudinary/url.util");
var logger_1 = require("./logger");
var server_messages_1 = require("./express/server.messages");
var strapi_middleware_1 = require("./express/middleware/strapi.middleware");
var decorate_request_1 = require("./express/middleware/decorate.request");
var redis_session_1 = require("./express/redis.session");
var debug_operator_1 = require("./redis/debug.operator");
var redis_connect_1 = require("./redis/redis.connect");
var search_service_1 = require("./redis/search.service");
var net_util_1 = require("./net/net.util");
var RedisOperators = __importStar(require("./redis/redis.operators"));
var Greeter = function (name) { return "Hello " + name; };
exports.Greeter = Greeter;
exports.env = env_1.default;
exports.envN = env_2.envN;
exports.Cloudinary = {
    extractRelativeUrl: url_util_1.extractRelativeUrl,
};
exports.Logger = {
    logger: logger_1.logger,
    setLogger: logger_1.setLogger,
};
exports.NET = {
    getIPAdress: net_util_1.getIPAdress,
};
exports.Express = {
    displaySuccessMessage: server_messages_1.displaySuccessMessage,
    createStrapiMiddleware: strapi_middleware_1.createStrapiMiddleware,
    createRequestDecorator: decorate_request_1.createRequestDecorator,
    createRedisSessionMiddlewares$: redis_session_1.createRedisSessionMiddlewares$,
};
exports.RX = {
    debugKeyRx: debug_operator_1.debugKeyRx,
    debugMessageRx: debug_operator_1.debugMessageRx,
    debugrx: debug_operator_1.debugrx,
};
exports.Redis = __assign(__assign({}, RedisOperators), { createRedis: redis_connect_1.createRedis, redisClient: redis_connect_1.redisClient, searchService: search_service_1.searchService, searchService$: search_service_1.searchService$ });
