"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.debugMessageRx = exports.debugKeyRx = exports.debugrx = void 0;
var operators_1 = require("rxjs/operators");
var logger_1 = require("../logger");
var debugrx = function (message) { return function (source) {
    return source.pipe(operators_1.tap(function (val) {
        logger_1.logger().info(message + " : " + val);
    }));
}; };
exports.debugrx = debugrx;
var debugKeyRx = function (message, key) { return function (source) {
    return source.pipe(operators_1.tap(function (val) {
        logger_1.logger().info(message + " :  " + (val !== null && val !== void 0 ? val : {}) + "[" + key + "]");
    }));
}; };
exports.debugKeyRx = debugKeyRx;
var debugMessageRx = function (message) { return function (source) {
    return source.pipe(operators_1.tap(function (val) {
        logger_1.logger().info(message + " : " + !!val);
    }));
}; };
exports.debugMessageRx = debugMessageRx;
