"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.redisIndexNumDocs = exports.redisFTInfo$ = exports.redisJSONSetX = exports.redisExpire = exports.redisJSONSet = exports.redisJSONMustGet$ = exports.redisJSONGet$ = exports.redisSetX$ = exports.redisSet$ = exports.redisMusGet$ = exports.redisGet$ = void 0;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var debug_operator_1 = require("./debug.operator");
function redisGet$(_a) {
    var redisClient = _a.redisClient, key = _a.key;
    return rxjs_1.from(redisClient.redis.get(key)).pipe(debug_operator_1.debugMessageRx("Redis get(" + key + ")"));
}
exports.redisGet$ = redisGet$;
function redisMusGet$(_a) {
    var redisClient = _a.redisClient, key = _a.key;
    return rxjs_1.from(redisClient.redis.get(key)).pipe(operators_1.filter(function (json) { return json !== null; }), operators_1.throwIfEmpty(function () { return new Error("Redis GET(" + key + ") not found"); }), debug_operator_1.debugMessageRx("Redis get(" + key + ")"));
}
exports.redisMusGet$ = redisMusGet$;
function redisSet$(_a) {
    var redisClient = _a.redisClient, key = _a.key, data = _a.data;
    return rxjs_1.from(redisClient.redis.set(key, data)).pipe(debug_operator_1.debugrx("Redis set(" + key + ")"));
}
exports.redisSet$ = redisSet$;
function redisSetX$(_a) {
    var redisClient = _a.redisClient, key = _a.key, seconds = _a.seconds, data = _a.data;
    return rxjs_1.from(redisClient.redis.setex(key, seconds, data)).pipe(debug_operator_1.debugrx("Redis setx(" + key + "," + seconds + ")"));
}
exports.redisSetX$ = redisSetX$;
function redisJSONGet$(_a) {
    var redisClient = _a.redisClient, key = _a.key;
    return rxjs_1.from(redisClient.rejson_module_get(key, '.', { noescape: true })).pipe(operators_1.switchMap(function (json) { return rxjs_1.of(JSON.parse(json)); }), debug_operator_1.debugMessageRx("Redis JSON.GET(" + key + ")"));
}
exports.redisJSONGet$ = redisJSONGet$;
function redisJSONMustGet$(_a) {
    var redisClient = _a.redisClient, key = _a.key;
    return rxjs_1.from(redisClient.rejson_module_get(key, '.', { noescape: true })).pipe(operators_1.filter(function (json) { return json !== null; }), operators_1.throwIfEmpty(function () { return new Error("JSON.GET(" + key + ") not found"); }), debug_operator_1.debugMessageRx("Redis JSON.GET(" + key + ")"), operators_1.switchMap(function (json) { return rxjs_1.of(JSON.parse(json)); }));
}
exports.redisJSONMustGet$ = redisJSONMustGet$;
function redisJSONSet(_a) {
    var redisClient = _a.redisClient, key = _a.key, data = _a.data;
    return rxjs_1.from(redisClient.rejson_module_set(key, '.', data)).pipe(debug_operator_1.debugrx("Redis JSON.SET(" + key + ")"));
}
exports.redisJSONSet = redisJSONSet;
function redisExpire(_a) {
    var redisClient = _a.redisClient, key = _a.key, seconds = _a.seconds;
    return rxjs_1.from(redisClient.redis.expire(key, seconds)).pipe(debug_operator_1.debugrx("Redis expire(" + key + "," + seconds + ")"));
}
exports.redisExpire = redisExpire;
function redisJSONSetX(_a) {
    var redisClient = _a.redisClient, key = _a.key, data = _a.data, seconds = _a.seconds;
    return redisJSONSet({ redisClient: redisClient, key: key, data: data }).pipe(operators_1.switchMap(function () { return redisExpire({ redisClient: redisClient, key: key, seconds: seconds }); }));
}
exports.redisJSONSetX = redisJSONSetX;
function redisFTInfo$(_a) {
    var redisClient = _a.redisClient, key = _a.key;
    return rxjs_1.from(redisClient.search_module_info(key));
}
exports.redisFTInfo$ = redisFTInfo$;
function redisIndexNumDocs(_a) {
    var redisClient = _a.redisClient, key = _a.key;
    return redisFTInfo$({ redisClient: redisClient, key: key }).pipe(operators_1.map(function (info) { return Number(info.num_docs); }), debug_operator_1.debugrx("Number of Documents(" + key + ")"));
}
exports.redisIndexNumDocs = redisIndexNumDocs;
