"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.searchService$ = exports.searchService = void 0;
var rxjs_1 = require("rxjs");
var logger_1 = require("../logger");
function searchService(_a) {
    var indexName = _a.indexName, queryString = _a.queryString, options = _a.options, redisClient = _a.redisClient;
    return __awaiter(this, void 0, void 0, function () {
        var _b, _c, _d, limit, _e, offset, _f, _g, _h, field, _j, ascending, _k, returnFields, result, ftSearchParameters, searchResult, i, doc, fields, j, len, idxKey, idxValue, columnName, columnValue, err_1;
        return __generator(this, function (_l) {
            switch (_l.label) {
                case 0:
                    _b = options.limit, _c = _b === void 0 ? {} : _b, _d = _c.limit, limit = _d === void 0 ? 100 : _d, _e = _c.offset, offset = _e === void 0 ? 0 : _e;
                    _f = options.sortBy, _g = _f === void 0 ? {} : _f, _h = _g.field, field = _h === void 0 ? null : _h, _j = _g.ascending, ascending = _j === void 0 ? true : _j;
                    _k = options.returnFields, returnFields = _k === void 0 ? null : _k;
                    result = {
                        meta: {
                            totalResults: 0,
                            offset: offset,
                            limit: limit,
                            queryString: queryString,
                            message: '',
                        },
                        docs: [],
                    };
                    ftSearchParameters = {
                        withScores: true,
                        limit: {
                            first: offset,
                            num: limit,
                        },
                    };
                    if (field) {
                        ftSearchParameters.sortBy = {
                            field: field,
                            sort: ascending ? 'ASC' : 'DESC',
                        };
                    }
                    if (returnFields) {
                        ftSearchParameters.return = {
                            num: returnFields.length,
                            fields: returnFields,
                        };
                    }
                    logger_1.logger().info('Search services parameters:');
                    logger_1.logger().info('index name:', indexName);
                    logger_1.logger().info('query:', queryString);
                    logger_1.logger().info('parameters', JSON.stringify(ftSearchParameters, null, 2));
                    _l.label = 1;
                case 1:
                    _l.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, redisClient.search_module_search(indexName, queryString, ftSearchParameters)];
                case 2:
                    searchResult = _l.sent();
                    // console.log('Returned values ==================');
                    // console.log(JSON.stringify(searchResult, null, 2));
                    // console.log('Returned values ==================');
                    if (!searchResult) {
                        result.meta.message = 'FT.SEARCH returned empty';
                        return [2 /*return*/, result];
                    }
                    if (!Array.isArray(searchResult)) {
                        result.meta.totalResults = 1;
                        result.docs.push(__assign({ meta: {
                                score: 0,
                                id: searchResult['1'],
                            } }, searchResult['0']));
                        return [2 /*return*/, result];
                    }
                    if (!(searchResult === null || searchResult === void 0 ? void 0 : searchResult.length)) {
                        result.meta.message = 'FT.SEARCH returned empty';
                        return [2 /*return*/, result];
                    }
                    result.meta.totalResults = searchResult[0];
                    for (i = 1; i <= searchResult.length - 1; i++) {
                        doc = {
                            meta: {
                                score: Number(searchResult[i + 1]),
                                id: searchResult[i],
                            },
                        };
                        i = i + 2;
                        fields = searchResult[i];
                        if (fields) {
                            for (j = 0, len = fields.length; j < len; j++) {
                                idxKey = j;
                                idxValue = idxKey + 1;
                                j++;
                                columnName = fields[idxKey];
                                columnValue = fields[idxValue];
                                doc[columnName] = columnValue;
                            }
                        }
                        result.docs.push(doc);
                    }
                    return [2 /*return*/, result];
                case 3:
                    err_1 = _l.sent();
                    console.error(err_1);
                    result.meta.message = 'Error';
                    return [2 /*return*/, result];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.searchService = searchService;
// const searchServiceObs$ = bindNodeCallback(searchService);
function searchService$(_a) {
    var indexName = _a.indexName, queryString = _a.queryString, options = _a.options, redisClient = _a.redisClient;
    return rxjs_1.from(searchService({ indexName: indexName, queryString: queryString, options: options, redisClient: redisClient }));
}
exports.searchService$ = searchService$;
