/// <reference types="node" />
import MongoDB from 'mongodb';
import { IncomingMessage } from 'http';
import { Redis } from 'redis-modules-sdk';
import { HLogger } from './logger.types';
export interface AppUser {
    id?: string;
    isAuthenticated: boolean;
    username?: string;
    email?: string;
    jwt?: string;
}
export interface Request extends IncomingMessage {
    session: {
        LANGUAGE: string;
        user?: AppUser;
    };
    user: AppUser;
    redisClient: Redis;
    mongodbClient: MongoDB.Db;
    logger: HLogger;
    LANGUAGE: string;
    params?: {
        languageId?: string;
    };
    body?: object;
}
export interface ContextInfo {
    user: AppUser;
    redisClient: Redis;
    mongodbClient: MongoDB.Db;
    LANGUAGE: string;
    apolloClient: any;
}
