import { Redis } from 'redis-modules-sdk';
export interface RedisGetParms {
    redisClient: Redis;
    key: string;
}
export interface RedisSetParms extends RedisGetParms {
    data: string;
}
export interface RedisSetXParms extends RedisGetParms {
    seconds: number;
    data: string;
}
export interface RedisJsonSetParms extends RedisGetParms {
    data: string;
}
export interface RedisExpireParms extends RedisGetParms {
    seconds: number;
}
export interface RedisJsonSetXParms extends RedisGetParms {
    data: string;
    seconds: number;
}
export interface RedisSearchOptions {
    redisClient: Redis;
    indexName: string;
    queryString: string;
    options?: {
        limit?: {
            limit?: number;
            offset?: number;
        };
        sortBy?: {
            field?: string;
            ascending?: boolean;
        };
        returnFields?: {
            name: string;
            as?: string;
        }[];
    };
}
export interface RedisSearchResults {
    meta: {
        totalResults: number;
        offset: any;
        limit: any;
        queryString: string;
        message: string;
    };
    docs: any[];
}
